## heimer 1.19+git20200819

=== CMakeLists.txt ===
project(Heimer)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

if(POLICY CMP0005)
    cmake_policy(SET CMP0005 NEW)
endif()

if(POLICY CMP0020)
    cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0043)
    cmake_policy(SET CMP0043 NEW)
endif()

if(POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

# Global version
set(VERSION_MAJOR 1)
set(VERSION_MINOR 19)
set(VERSION_PATCH 0)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

# Some common CPack variables
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})

set(CPACK_PACKAGE_NAME heimer)
set(CPACK_PACKAGE_VENDOR Juzzlin)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Heimer is a simple cross-platform mind map tool written in Qt.")
set(CPACK_PACKAGE_ICON ${CMAKE_SOURCE_DIR}/data/images/about.png)

set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/COPYING)
set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README.md)

option(BIN_PATH "Optional BIN_PATH for Linux release build." "")

option(BUILD_TESTS "Build unit tests." ON)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

# Package type info shown in the About dialog
if(PACKAGE_TYPE)
    add_definitions(-DPACKAGE_TYPE="${PACKAGE_TYPE}")
endif()

if(UNIX)
    include("InstallLinux.cmake")
elseif(WIN32)
    include("InstallWindows.cmake")
endif()

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()

    # Automatically use ccache if found
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)

elseif(MSVC)
    add_definitions(-DNOMINMAX)
endif()

set(BINARY_NAME "heimer")
set(LIBRARY_NAME "HeimerLib")

add_definitions(-DVERSION="${VERSION}")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(QT_MIN_VER 5.5.1) # The version in Ubuntu 16.04
find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)
find_package(Qt5LinguistTools ${QT_MIN_VER} REQUIRED)
find_package(Qt5Svg ${QT_MIN_VER} REQUIRED)
find_package(Qt5Test ${QT_MIN_VER} REQUIRED)

# Install paths depend on the build type and target platform
setup_install_targets()

add_subdirectory(src)

# Enable CMake's unit test framework
if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(src/unit_tests)
endif()

=== src/unit_tests/editor_data_test/CMakeLists.txt ===
set(EDITOR_DIR ${CMAKE_SOURCE_DIR}/src)
include_directories(${EDITOR_DIR} ${EDITOR_DIR}/contrib ${CMAKE_CURRENT_SOURCE_DIR})
set(NAME editor_data_test)
set(SRC ${NAME}.cpp)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
add_executable(${NAME} ${SRC} ${MOC_SRC})
add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)

=== debian/changelog ===
heimer (1.19+git20200819-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 30 Aug 2020 02:29:37 -0400

## heimer 1.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Global version
 set(VERSION_MAJOR 1)
-set(VERSION_MINOR 19)
+set(VERSION_MINOR 20)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

=== src/CMakeLists.txt ===
add_subdirectory(contrib/SimpleLogger EXCLUDE_FROM_ALL)
include_directories(contrib/SimpleLogger/src)

add_subdirectory(contrib/Argengine EXCLUDE_FROM_ALL)
include_directories(contrib/Argengine/src)

# Translation files in src/translations (without .ts)
set(TS heimer_fi heimer_fr heimer_it heimer_nl)
set(TS_FILES)
set(QM_FILES)
foreach(TS_FILE ${TS})
    list(APPEND TS_FILES ${CMAKE_SOURCE_DIR}/src/translations/${TS_FILE}.ts)
    list(APPEND QM_FILES ${CMAKE_BINARY_DIR}/data/translations/${TS_FILE}.qm)
endforeach()
set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION ${CMAKE_BINARY_DIR}/data/translations)

# Set sources for the lib
set(LIB_SRC
    about_dlg.cpp
    alz_serializer.cpp
    application.cpp
    constants.hpp
    copy_paste.cpp
    edge.cpp
    edge_context_menu.cpp
    edge_dot.cpp
    edge_point.hpp
    edge_text_edit.cpp
    editor_data.cpp
    editor_scene.cpp
    editor_view.cpp
    file_exception.hpp
    graph.cpp
    graphics_factory.cpp
    grid.cpp
    hash_seed.cpp
    image.cpp
    image_manager.cpp
    layers.hpp
    layout_optimization_dialog.cpp
    layout_optimizer.cpp
    magic_zoom.cpp
    main_context_menu.cpp
    main_window.cpp
    mediator.cpp
    mind_map_data.cpp
    mind_map_data_base.cpp
    mouse_action.cpp
    node.cpp
    node_handle.cpp
    png_export_dialog.cpp
    recent_files_manager.cpp
    recent_files_menu.cpp
    selection_group.cpp
    settings.cpp
    state_machine.cpp
    svg_export_dialog.cpp
    test_mode.cpp
    text_edit.cpp
    undo_stack.cpp
    user_exception.hpp
    whats_new_dlg.cpp
    xml_reader.cpp
    xml_writer.cpp
)

# Set sources for the app
set(APP_SRC
    main.cpp
)

# Need to copy the QRC file to binary dir where the QM-files will be generated.
# This is because the paths in translations.qrc are relative to itself.
configure_file(${CMAKE_SOURCE_DIR}/data/translations/translations.qrc ${CMAKE_BINARY_DIR}/data/translations/translations.qrc COPYONLY)

set(RCS
    ${CMAKE_SOURCE_DIR}/meta.qrc
    ${CMAKE_SOURCE_DIR}/data/images/images.qrc
    ${CMAKE_SOURCE_DIR}/data/icons/icons.qrc
    ${CMAKE_BINARY_DIR}/data/translations/translations.qrc
)

qt5_add_resources(RC_SRC ${RCS})
qt5_add_translation(QM ${TS_FILES})
qt5_wrap_ui(UI_HDRS ${UIS})

# We need this to be able to include headers produced by uic in our code
include_directories(${CMAKE_BINARY_DIR})

# Resource compilation for MinGW
if(MINGW)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o
        COMMAND
            ${CMAKE_RC_COMPILER}
            -I${CMAKE_SOURCE_DIR} -i${CMAKE_SOURCE_DIR}/data/icons/WindowsHeimer.rc
            -o ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
    set(APP_SRC ${APP_SRC} ${CMAKE_CURRENT_BINARY_DIR}/windowsrc.o)
endif()

# Copy desktop file
if(UNIX)
    set(DesktopFileSourcePath)
    if(USC)
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/heimer.desktop.opt.in)
    else()
        set(DesktopFileSourcePath ${CMAKE_SOURCE_DIR}/src/heimer.desktop.in)
    endif()
    add_custom_target(desktop-file ALL
        COMMAND cmake -E copy ${DesktopFileSourcePath}
            ${CMAKE_BINARY_DIR}/heimer.desktop
    DEPENDS ${BINARY_NAME})
endif()

# Add the library
add_library(${LIBRARY_NAME} STATIC ${LIB_SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
target_link_libraries(${LIBRARY_NAME} Qt5::Widgets Qt5::Svg Qt5::Xml SimpleLogger_static Argengine_static)

# Add the executable
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
add_executable(${BINARY_NAME} WIN32 ${APP_SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
target_link_libraries(${BINARY_NAME} Qt5::Widgets ${LIBRARY_NAME})

=== src/unit_tests/graph_test/CMakeLists.txt ===
set(EDITOR_DIR ${CMAKE_SOURCE_DIR}/src)
include_directories(${EDITOR_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
set(NAME graph_test)
set(SRC ${NAME}.cpp)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
add_executable(${NAME} ${SRC} ${MOC_SRC})
add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Widgets SimpleLogger_static)

=== src/unit_tests/layout_optimizer_test/CMakeLists.txt ===
set(EDITOR_DIR ${CMAKE_SOURCE_DIR}/src)
include_directories(${EDITOR_DIR} ${EDITOR_DIR}/contrib ${CMAKE_CURRENT_SOURCE_DIR})
set(NAME layout_optimizer_test)
set(SRC ${NAME}.cpp)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
add_executable(${NAME} ${SRC} ${MOC_SRC})
add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)

=== src/unit_tests/serializer_test/CMakeLists.txt ===
set(EDITOR_DIR ${CMAKE_SOURCE_DIR}/src)
include_directories(${EDITOR_DIR} ${EDITOR_DIR}/contrib ${CMAKE_CURRENT_SOURCE_DIR})
set(NAME serializer_test)
set(SRC ${NAME}.cpp)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
add_executable(${NAME} ${SRC} ${MOC_SRC})
add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)

=== debian/changelog ===
heimer (1.20.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 07 Oct 2020 17:31:50 -0400

## heimer 1.21.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Global version
 set(VERSION_MAJOR 1)
-set(VERSION_MINOR 20)
+set(VERSION_MINOR 21)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,8 @@
     application.cpp
     constants.hpp
     copy_paste.cpp
+    defaults.cpp
+    defaults_dlg.cpp
     edge.cpp
     edge_context_menu.cpp
     edge_dot.cpp

=== debian/changelog ===
heimer (1.21.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 26 Oct 2020 13:57:10 -0400

## heimer 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,8 +20,8 @@
 endif()
 
 # Global version
-set(VERSION_MAJOR 1)
-set(VERSION_MINOR 21)
+set(VERSION_MAJOR 2)
+set(VERSION_MINOR 1)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,6 @@
     alz_serializer.cpp
     application.cpp
     constants.hpp
-    copy_paste.cpp
     defaults.cpp
     defaults_dlg.cpp
     edge.cpp
@@ -49,6 +48,7 @@
     mind_map_data_base.cpp
     mouse_action.cpp
     node.cpp
+    node_action.hpp
     node_handle.cpp
     png_export_dialog.cpp
     recent_files_manager.cpp

=== debian/changelog ===
heimer (2.1.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 07 Jan 2021 01:48:38 -0500

## heimer 2.2.0%2Bgit20210202

=== debian/changelog ===
heimer (2.2.0+git20210202-1~mx19+2) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.

 -- SwampRabbit <maintainer@mepiscommunity.org>  Sat, 06 Feb 2021 01:10:29 -0500

## heimer 2.2.0+git20210202

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Global version
 set(VERSION_MAJOR 2)
-set(VERSION_MINOR 1)
+set(VERSION_MINOR 2)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
@@ -90,12 +90,9 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(QT_MIN_VER 5.5.1) # The version in Ubuntu 16.04
-find_package(Qt5Core ${QT_MIN_VER} REQUIRED)
-find_package(Qt5Xml ${QT_MIN_VER} REQUIRED)
-find_package(Qt5Widgets ${QT_MIN_VER} REQUIRED)
-find_package(Qt5LinguistTools ${QT_MIN_VER} REQUIRED)
-find_package(Qt5Svg ${QT_MIN_VER} REQUIRED)
-find_package(Qt5Test ${QT_MIN_VER} REQUIRED)
+# This is what Qt Creator 4.13.2 would generate
+find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
+find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Xml Widgets LinguistTools Svg Test REQUIRED)
 
 # Install paths depend on the build type and target platform
 setup_install_targets()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -82,9 +82,16 @@
     ${CMAKE_BINARY_DIR}/data/translations/translations.qrc
 )
 
-qt5_add_resources(RC_SRC ${RCS})
-qt5_add_translation(QM ${TS_FILES})
-qt5_wrap_ui(UI_HDRS ${UIS})
+if(${QT_VERSION_MAJOR} STREQUAL "6")
+    qt_add_resources(RC_SRC ${RCS})
+    qt_add_translation(QM ${TS_FILES})
+    qt_wrap_ui(UI_HDRS ${UIS})
+# This is needed for Qt < 5.15
+else()
+    qt5_add_resources(RC_SRC ${RCS})
+    qt5_add_translation(QM ${TS_FILES})
+    qt5_wrap_ui(UI_HDRS ${UIS})
+endif()
 
 # We need this to be able to include headers produced by uic in our code
 include_directories(${CMAKE_BINARY_DIR})
@@ -116,9 +123,9 @@
 
 # Add the library
 add_library(${LIBRARY_NAME} STATIC ${LIB_SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
-target_link_libraries(${LIBRARY_NAME} Qt5::Widgets Qt5::Svg Qt5::Xml SimpleLogger_static Argengine_static)
+target_link_libraries(${LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Svg Qt${QT_VERSION_MAJOR}::Xml SimpleLogger_static Argengine_static)
 
 # Add the executable
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 add_executable(${BINARY_NAME} WIN32 ${APP_SRC} ${MOC_SRC} ${RC_SRC} ${UI_HDRS} ${QM})
-target_link_libraries(${BINARY_NAME} Qt5::Widgets ${LIBRARY_NAME})
+target_link_libraries(${BINARY_NAME} Qt${QT_VERSION_MAJOR}::Widgets ${LIBRARY_NAME})

## heimer 2.4.0+github20210412

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Global version
 set(VERSION_MAJOR 2)
-set(VERSION_MINOR 2)
+set(VERSION_MINOR 4)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

=== src/unit_tests/serializer_test/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,4 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
 add_executable(${NAME} ${SRC} ${MOC_SRC})
 add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
-target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)
+target_link_libraries(${NAME} ${LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Xml Qt${QT_VERSION_MAJOR}::Widgets SimpleLogger_static)

=== debian/changelog ===
heimer (2.4.0+github20210412-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 20 Apr 2021 12:14:17 -0400

## heimer 2.5.0%2Bgit20210501

=== debian/changelog ===
heimer (2.5.0+git20210501-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 04 May 2021 16:05:21 -0400

## heimer 2.5.0+git20210501

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 # Global version
 set(VERSION_MAJOR 2)
-set(VERSION_MINOR 4)
+set(VERSION_MINOR 5)
 set(VERSION_PATCH 0)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,14 +19,15 @@
     about_dlg.cpp
     alz_serializer.cpp
     application.cpp
+    color_dialog.cpp
     constants.hpp
-    defaults.cpp
-    defaults_dlg.cpp
+    defaults_tab.cpp
     edge.cpp
     edge_context_menu.cpp
     edge_dot.cpp
     edge_point.hpp
     edge_text_edit.cpp
+    editing_tab.cpp
     editor_data.cpp
     editor_scene.cpp
     editor_view.cpp
@@ -55,6 +56,8 @@
     recent_files_menu.cpp
     selection_group.cpp
     settings.cpp
+    settings_dialog.cpp
+    settings_proxy.cpp
     state_machine.cpp
     svg_export_dialog.cpp
     test_mode.cpp
@@ -62,6 +65,7 @@
     undo_stack.cpp
     user_exception.hpp
     whats_new_dlg.cpp
+    widget_factory.cpp
     xml_reader.cpp
     xml_writer.cpp
 )

=== src/unit_tests/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/SimpleLogger/src)

add_subdirectory(editor_data_test)
add_subdirectory(graph_test)
add_subdirectory(layout_optimizer_test)
add_subdirectory(serializer_test)

=== src/contrib/Argengine/CMakeLists.txt ===
project(Argengine)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

option(BUILD_EXAMPLES "Build example apps" ON)

option(BUILD_TESTS "Build unit tests" ON)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()
endif()

set(LIBRARY_NAME "Argengine")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(src/tests)
endif()

add_subdirectory(src)

=== src/contrib/SimpleLogger/CMakeLists.txt ===
project(SimpleLogger)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

option(BUILD_TESTS "Build unit tests" ON)

# Default to release C++ flags if CMAKE_BUILD_TYPE not set
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
MinSizeRel." FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")

    # CMAKE_CXX_STANDARD supported only by versions >= 3.1
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    endif ()
endif()

set(LIBRARY_NAME "SimpleLogger")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(src/tests)
endif()

add_subdirectory(src)

=== src/unit_tests/editor_data_test/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,4 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
 add_executable(${NAME} ${SRC} ${MOC_SRC})
 add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
-target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)
+target_link_libraries(${NAME} ${LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Xml Qt${QT_VERSION_MAJOR}::Widgets SimpleLogger_static)

=== src/unit_tests/graph_test/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,4 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
 add_executable(${NAME} ${SRC} ${MOC_SRC})
 add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
-target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Widgets SimpleLogger_static)
+target_link_libraries(${NAME} ${LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Widgets SimpleLogger_static)

=== src/unit_tests/layout_optimizer_test/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,4 @@
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/unit_tests)
 add_executable(${NAME} ${SRC} ${MOC_SRC})
 add_test(${NAME} ${CMAKE_BINARY_DIR}/unit_tests/${NAME})
-target_link_libraries(${NAME} ${LIBRARY_NAME} Qt5::Test Qt5::Xml Qt5::Widgets SimpleLogger_static)
+target_link_libraries(${NAME} ${LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Xml Qt${QT_VERSION_MAJOR}::Widgets SimpleLogger_static)

=== debian/changelog ===
heimer (2.5.0+git20210501-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 04 May 2021 16:05:21 -0400

=== debian/control ===
Source: heimer
Section: education
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Jussi Lind <jussi.lind@iki.fi>
Build-Depends: cmake,
			   debhelper-compat (= 12),
			   pkg-config,
			   qt5-default,
			   qttools5-dev-tools,
			   qttools5-dev,
			   libqt5svg5-dev
Standards-Version: 4.5.0
Homepage: http://juzzlin.github.io/Heimer/index.html
Vcs-Git: git@github.com:juzzlin/Heimer.git

Package: heimer
Architecture: amd64
Depends: ${misc:Depends}, ${shlibs:Depends}, hicolor-icon-theme
Description: An application for creating and managing mind maps
 Heimer is a desktop application for creating and managing mind maps and
  other suitable diagrams.
 .
 Heimer has the following features:
 - Adjustable grid
 - Automatic layout optimization
 - Export to PNG or SVG
 - Quickly add node text and edge labels

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  

override_dh_strip:
	dh_strip --no-automatic-dbgsym

#override_dh_auto_configure:
#	dh_auto_configure -- \
#	      -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)"
